#include "blocks.h"

extern MAP_BLOCK** indirect_blockmap1;
extern ADDRESS indirect_blockmap_start1;
extern INT64 indirect_blockmap_size1;

extern MAP_BLOCK** indirect_blockmap2;
extern ADDRESS indirect_blockmap_start2;
extern INT64 indirect_blockmap_size2;


extern ADDRESS AblockMapAddress(INDEX isec, ADDRESS addr)
{
  int tel;
  MAP_BLOCK * tmp;
  if (addr<=indirect_blockmap_start1+indirect_blockmap_size1 || addr<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlock(addr)))
      return ((INT64) tmp->data) + addr - tmp->start;
  for (tel=0; tel<numsections; tel++)

    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)  /* this should give it another speedup ! */

      {
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	if (isec!=BIN_SECTION_MAP[map_sections[tel].type]) continue;
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((addr-tmp->start)>=0)
	      if ((addr-tmp->start)<tmp->size)
		{
		  return ((INT64) tmp->data) + addr - tmp->start;
		}
	  }
	
	
      }
  return -1;
}

extern int AsecBlockContainsAddress(INDEX isec, ADDRESS addr) 
{
  int tel;
  //  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)

    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)

      {
	
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	if (isec!=BIN_SECTION_MAP[map_sections[tel].type]) continue;
	/*  for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	    {
	    if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	    {
	    return 1;
	    }
	    }
	    printf("PPPPPPPRRRRRRRROOOOOOOOOBBBBBBBBLLLLLLLLEEEEEEEEMMMMMMMMSSSSSSSS\n");
	    return 0;
	*/
	return 1; /* this speeds up squeeze tremendously, don't know whether it is correct */
      }
  return -1;
}

extern int AsecblockWriteData32(INDEX isec, NUMBER index, INT32 value)
{
  ADDRESS addr=ASEC_START(isec)+4*index;
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      if (isec!=BIN_SECTION_MAP[map_sections[tel].type]) continue;
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*((INT32 *) (tmp->data+(addr-tmp->start)))=value;
		return 0; 
	      }
	}


    }

  return -1;
}

extern int AblockReadData64(ADDRESS addr, INT64 * value)
{
  int tel;
  MAP_BLOCK * tmp;
  if (addr<=indirect_blockmap_start1+indirect_blockmap_size1 || addr<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlock(addr)))
      {
	//	printf("address %lx start %lx size %lx\n",addr,tmp->start,tmp->size);
	//printf("tmp %lx tmp->data %lx (((addr-tmp->start)>>3)<<3) %lx\n",tmp,tmp->data,(((addr-tmp->start)>>3)<<3));
	*value=*((INT64 *) (tmp->data+(((addr-tmp->start)>>3)<<3)));
	return 0;
      }
  for (tel=0; tel<numsections; tel++)
    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)     
      {
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((addr-tmp->start)>=0)
	      if ((addr-tmp->start)<tmp->size)
		{
		  *value=*((INT64 *) (tmp->data+(((addr-tmp->start)>>3)<<3)));
		  return 0; 
		}
	  }
      }
  return -1;
}

extern int AblockReadData32(ADDRESS addr, INT32 * value)
{
  int tel;
  MAP_BLOCK * tmp;
  if (addr<=indirect_blockmap_start1+indirect_blockmap_size1 || addr<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlock(addr)))
      {
	*value= *((INT32 *) (tmp->data+(((addr-tmp->start)>>2)<<2)));
	return 0;
      }
  for (tel=0; tel<numsections; tel++)
    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)     
      {
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((addr-tmp->start)>=0)
	      if ((addr-tmp->start)<tmp->size)
		{
		  *value=*((INT32 *) (tmp->data+(((addr-tmp->start)>>2)<<2)));
		  return 0; 
		}
	  }
      }
  return -1;
}
extern int AblockReadData16(ADDRESS addr, INT16 * value)
{
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*value=*((INT16 *) (tmp->data+(((addr-tmp->start)>>1)<<1)));
		return 0; 
	      }
	}
    }
  return -1;
}


extern int AblockReadData8(ADDRESS addr, INT8 * value)
{
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*value=*((INT8 *) (tmp->data+(((addr-tmp->start)))));
		return 0; 
	      }
	}
    }
  return -1;
}

extern int AsecblockReadData32(INDEX isec, NUMBER index, INT32 * value)
{
  ADDRESS addr=ASEC_START(isec)+4*index;
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      if (isec!=BIN_SECTION_MAP[map_sections[tel].type]) continue;
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*value=*((INT32 *) (tmp->data+(addr-tmp->start)));
		return 0; 
	      }
	}


    }

  return -1;
}
extern int AblockWriteData64(ADDRESS addr, INT64 value)
{
  int tel;
  MAP_BLOCK * tmp;
  if (addr<=indirect_blockmap_start1+indirect_blockmap_size1 || addr<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlock(addr)))
      {
	*((INT64 *) (tmp->data+(((addr-tmp->start)>>3)<<3)))=value;
	return 0;
      }  
  for (tel=0; tel<numsections; tel++)
    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)  
      {
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((addr-tmp->start)>=0)
	      if ((addr-tmp->start)<tmp->size)
		{
		  *((INT64 *) (tmp->data+(((addr-tmp->start)>>3)<<3)))=value;
		  return 0; 
		}
	  }
      }
  return -1;
}

extern int AblockWriteData32(ADDRESS addr, INT32 value)
{
  int tel;
  MAP_BLOCK * tmp;
  if (addr<=indirect_blockmap_start1+indirect_blockmap_size1 || addr<=indirect_blockmap_start2+indirect_blockmap_size2)
    if ((tmp = LocateBlock(addr)))
      {
	*((INT32 *) (tmp->data+(((addr-tmp->start)>>2)<<2)))=value;
	return 0;
      }  
  for (tel=0; tel<numsections; tel++)
    if (
	(addr>=map_sections[tel].start && addr<map_sections[tel].start+map_sections[tel].size) ||
	(addr>=map_sections[tel].dead_start && addr<map_sections[tel].dead_start+map_sections[tel].dead_size)
	)     
      {   
	if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
	for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	  {
	    if ((addr-tmp->start)>=0)
	      if ((addr-tmp->start)<tmp->size)
		{
		  *((INT32 *) (tmp->data+(((addr-tmp->start)>>2)<<2)))=value;
		  return 0; 
		}
	  }
      }
  return -1;
}

extern int AblockWriteData16(ADDRESS addr, INT16 value)
{
  int tel;
  MAP_BLOCK * tmp;

  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*((INT16 *) (tmp->data+(((addr-tmp->start)>>1)<<1)))=value;
		return 0; 
	      }
	}
    }
  return -1;
}
extern int AblockWriteData8(ADDRESS addr, INT8 value)
{
  int tel;
  MAP_BLOCK * tmp;
  for (tel=0; tel<numsections; tel++)
    {
      if (!(TYPE_IS_BLOCK(map_sections[tel].type))) continue; 
      for (tmp=map_sections[tel].first; tmp!=NULL; tmp=tmp->next)
	{
	  if ((addr-tmp->start)>=0)
	    if ((addr-tmp->start)<tmp->size)
	      {
		*((INT8 *) (tmp->data+(addr-tmp->start)))=value;
		return 0; 
	      }
	}
    }
  return -1;
}

