/*=======================================================
  Author:   R. Muth
  Version:  $Id: opt.constants2.c,v 1.1.1.1 2000/06/07 12:37:02 brdsutte Exp $
  Comment:  This file contains the optimization code for constants
=======================================================*/

#include "global.h"
#include "flags.h"
#include "opcode.h"
#include "functions.h"
#include "regs.h"

/*=======================================================
@OPT
Compute constants faster.
use lda, ldah with rzero or gp
substitute a load if instruction is expensive
TODO: use lda/ldah pairs for 32 bit instructions
@END
=======================================================*/
#undef __PROC__
#define __PROC__ "OptConstGenOneNew"

extern BOOL OptConstGenOneNew(FILE *fp,INDEX ibbl,INDEX iins,VALUESPEC * before)
{
  BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"Constgenone");
  BOOL change = 0;
  INDEX jins;
  NUMBER ccount=0;
  NUMBER ccounth=0;
  REG reg;
  INT64 value; 
  INT64 value2;
  INT64 value3;
  INT64 regval; 
  INT32 hi,lo;
  INT32 i;
  REGLIST list=REGSET_DIFF(AinsRegsLiveAfter(iins),AinsDef(iins));

  clock_t time = clock();
    
  if( ibbl <= 6 ) return 0;   /* GROSS HACK NEEDS WORK*/

  if( !(AINS_FLAGS(iins) & FI_EVAL_C) ) return 0;
  reg = AINS_REG_C(iins);
  if( reg == REG_ZERO || reg == REG_FZERO  || reg == REG_GP ) return 0;
  value = AINS_C_EVAL(iins);

     
  /* check whether it is in the text segement */

  if( AddressIsCode(value) ) return 0;
  if( AinsHasSideEffect(iins) ) return 0;
  if( REG_IS_INT(reg) )
    {


      /* ====================================================================== */
            
      if( AINS_CODE(iins) == I_lda && AINS_REG_B(iins) == REG_ZERO ) return 0;    


      if( -(1L<<15) <=  value  && value < (1L<<15) )
	{
	  AinsMakeLda(iins,REG_ZERO,reg,value);
	  goto did_something;
	}

      /* ====================================================================== */
            
      if( AINS_CODE(iins) == I_ldah && AINS_REG_B(iins) == REG_ZERO ) return 0;

      if( (value & 0xffff) == 0 && ((-(1L<<15))<<16) <= value && value < (1L<<31) )
	{
	  AinsMakeLdah(iins,REG_ZERO,reg,value>>16);
	  goto did_something;
	}

      /* ====================================================================== */
      value2 = value - SysGetGlobalPointer();
      /* ====================================================================== */
            
      if( AINS_CODE(iins) == I_lda )
            
	if( -(1L<<15) <=  value2  && value2 < (1L<<15) )
	  {
	    AinsMakeLda(iins,REG_GP,reg,value2);
	    goto did_something;
	  }


      /* ====================================================================== */
      /* Bruno */
            
      if( AINS_TYPE(iins) == IT_LDA || AINS_TYPE(iins) == IT_FCS ) return 0;
#if 1
      if (!(AddressIsCode(before->value[AINS_REG_A(iins)].i)))
	if (AINS_REG_B(iins)==REG_LIT || !(AddressIsCode(before->value[AINS_REG_B(iins)].i)))
	  if (AINS_REG_A(iins)!=REG_GP && AINS_REG_B(iins)!=REG_GP)
	    for (i=0; i<31; i++)
	      {
		if (i==REG_GP) continue;
		if ((before->top | before->bot) & REG2BIT(i)) continue;
		regval=before->value[i].i;
		if ((AddressIsCode(regval))) continue; 
		value3=value-regval;
		if( value3 == 0 )
		  {
		    AinsMakeLda(iins,i,reg,value3);
		    goto did_something;
		  }
		      
	      }
#endif
	    
      if (!(AddressIsCode(before->value[AINS_REG_A(iins)].i)))
	if (AINS_REG_B(iins)==REG_LIT || !(AddressIsCode(before->value[AINS_REG_B(iins)].i)))
	  if (AINS_REG_A(iins)!=REG_GP && AINS_REG_B(iins)!=REG_GP)
	    {
	      REGSET_FOREACH_REG(list & ~REG2BIT(REG_ZERO) & ~REG2BIT(REG_GP) & REGS_INT,i)
		{
		  if ((before->top | before->bot) & REG2BIT(i)) continue;
		  regval=before->value[i].i;
		  if ((AddressIsCode(regval))) continue; 
		  value3=value - regval;
		  if( -(1L<<15) <=  value3  && value3 < (1L<<15) )
		    {
		      AinsMakeLda(iins,i,reg,value3);
		      goto did_something;
		    }
		}

	      if (!((REG2BIT(AINS_REG_A(iins))&list)&&(REG2BIT(AINS_REG_B(iins))&list)))
		{
		  REGSET_FOREACH_REG(~REG2BIT(REG_ZERO) & ~REG2BIT(REG_GP) & REGS_INT,i)
		    {
		      if ((before->top | before->bot) & REG2BIT(i)) continue;
		      regval=before->value[i].i;
		      if ((AddressIsCode(regval))) continue; 
		      value3=value - regval;
		      if( -(1L<<15) <=  value3  && value3 < (1L<<15) )
			{
			  AinsMakeLda(iins,i,reg,value3);
			  goto did_something;
			}
		    }
		}
	    }

      if (!(AddressIsCode(before->value[AINS_REG_A(iins)].i)))
	if (AINS_REG_B(iins)==REG_LIT || !(AddressIsCode(before->value[AINS_REG_B(iins)].i)))
	  if (AINS_REG_A(iins)!=REG_GP && AINS_REG_B(iins)!=REG_GP)
	    {
	      REGSET_FOREACH_REG(list & ~REG2BIT(REG_ZERO) & ~REG2BIT(REG_GP) & REGS_INT,i)
		{
		  if ((before->top | before->bot) & REG2BIT(i)) continue;
		  regval=before->value[i].i;
		  if ((AddressIsCode(regval))) continue; 
		  value3=value - regval;
		  if( -(1L<<15) <=  value3  && value3 < (1L<<15) )
		    {
		      AinsMakeLda(iins,i,reg,value3);
		      goto did_something;
		    }
		}

	      if (!((REG2BIT(AINS_REG_A(iins))&list)&&(REG2BIT(AINS_REG_B(iins))&list)))
		{
		  REGSET_FOREACH_REG(~REG2BIT(REG_ZERO) & ~REG2BIT(REG_GP) & REGS_INT,i)
		    {
		      if ((before->top | before->bot) & REG2BIT(i)) continue;
		      regval=before->value[i].i;
		      if ((AddressIsCode(regval))) continue; 
		      value3=value - regval;
		      if( (value3 & 0xffff) == 0 && ((-(1L<<15))<<16) <= value3 && value3 < (1L<<31) )
			{
			  AinsMakeLdah(iins,i,reg,value3>>16);
			  goto did_something;
			}
		    }
		}
	    }
	    
      if( AINS_TYPE(iins) == IT_LDA || AINS_TYPE(iins) == IT_FCS ) return 0;

      if( -(1L<<30) <=  value  && value < (1L<<30) )
	{
	  hi = value >> 16;
	  lo = value & 0xffff;
	  if( lo & 0x8000 )
	    {
	      lo |= 0xffff0000;
	      hi += 1;
	    }

	  CASSERT( (hi << 16) + lo == value,("weird\n"));
	  jins = AinsNew();
#if 0
	  HURRAH(("did 32 constant: %16lx with instruction %d\n",value,iins));
	  PrintBblSuper(stdout,AINS_BBL(iins));
#endif
	  AinsMakeLdah(jins,REG_ZERO,reg,hi);
	  AINS_BBL(jins) = AINS_BBL(iins);
	  AinsInsertBefore(jins,iins);                
	  AinsMakeLda(iins,reg,reg,lo);
	  goto did_something;
	}
      /* ====================================================================== */
      if( -(1L<<30) <=  value2  && value2 < (1L<<30) )
	{
	  hi = value2 >> 16;
	  lo = value2 & 0xffff;
	  if( lo & 0x8000 )
	    {
	      lo |= 0xffff0000;
	      hi += 1;
	    }

	  CASSERT( (hi << 16) + lo == value2,("weird\n"));
	  jins = AinsNew();
#if 0
	  HURRAH(("did 32 constant: %16lx with instruction %d\n",value,iins));
	  PrintBblSuper(stdout,AINS_BBL(iins));
#endif
	  AinsMakeLdah(jins,REG_GP,reg,hi);
	  AINS_BBL(jins) = AINS_BBL(iins);
	  AinsInsertBefore(jins,iins);                
	  AinsMakeLda(iins,reg,reg,lo);
	  goto did_something;
	}

      /* ====================================================================== */




      /* ====================================================================== */
            
      if( AINS_TYPE(iins) == IT_MLL || AINS_TYPE(iins) == IT_MLQ || AINS_TYPE(iins) == IT_MLH )
	{
	  POTENTIAL(("constant ins %d [%s] val: %016lx bbl: %d (%ld)\n",iins,AINS_NAME(iins),value,ibbl,ABBL_COUNT(ibbl)));
#if 0
	  PrintBblSuper(stdout,ibbl);
#endif
	}
                
    }
  else
    {
      double d;

      if( value == 0 || value == (1L<<63) )
	{
	  if( AINS_CODE(iins) == I_cpys || AINS_CODE(iins) == I_cpysn ) return 0;
	}
            
      if( AINS_TYPE(iins) == IT_FLD ) return 0;
      if( AINS_TYPE(iins) == IT_FCS ) return 0;
      if( ABBL_IS_HOT(AINS_BBL(iins)) )
	{
	  *((INT64 *)&d) = value;
	  POTENTIAL(("constant ins %d [%s] val: %8f  bbl: %d (%ld)\n",iins,AINS_NAME(iins),d,ibbl,ABBL_COUNT(ibbl)));
#if 0
	  PrintBblSuper(stdout,ibbl);
#endif
	}
    }


  return 0;
        
 did_something:
  AINS_FLAGS(iins) |= FI_EVAL_C;
  AINS_C_EVAL(iins) = value;
  ccount++;    
  if( ABBL_IS_HOT(ibbl) )
    ccounth++;
        
  if( verbose )
    {
      fprintf(fp,"\t[*] ins %d created %s for value: %16lx\n",iins,AINS_NAME(iins),value);
    }

  time = (clock() - time) * 1000 / CLOCKS_PER_SEC;
  change = (ccount > 0);

  //    InfoStatus(fp,"\t[OptConstgenone%c] Optimized Constants: %d#%d {%d ms}\n",CHANGE(change),ccount,ccounth,time);

  return 1;
}


/*=======================================================
@OPTIMIZATION
Sophisticated constant propagation.
We resuse a constant in some other register to (hopefully) reduce 
register usage.
This is only done on the basic block level.
We do not kill instructions but expect useless code to be eliminated
by other optimizations.
We also allow construction of values from other using
either explict lda's or doing it implicitly for
memory format instruction. Care must be taken to not construct
values that point into code sections since those values
may change!!!
@END
=======================================================*/
#undef __PROC__
#define __PROC__ "OptConstGenTwoNew"

extern BOOL OptConstGenTwoNew(FILE *fp,INDEX ibbl)
{
  BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"GENTWO"); 
  BOOL   change = 0;
  NUMBER pcount = 0;
  NUMBER pcounth = 0;
  REG    reg;
    
  clock_t time = clock();

  INDEX  iins;


    
  REGLIST hasValue;
  INT64   CurrValue[64];
  NUMBER  LastDef[64];
  NUMBER  no;
  VALUESPEC * input=GetBblValueSpec(ibbl);

  if( ABBL_FLAGS(ibbl) & FB_PROG_ENTRY ) return 0;
    
  no = 0;
    
  hasValue = B_ZERO | B_FZERO | B_GP;
  for(reg=0;reg<64;reg++)
    {
      LastDef[reg]=-666;
      if (input!=NULL)
	if (!((input->top | input->bot) & REG2BIT(reg)))
	  {
	    CurrValue[reg]=input->value[reg].i;
	    hasValue |=REG2BIT(reg); 
	  }
    }
    
  CurrValue[REG_ZERO] = 0;
  CurrValue[REG_FZERO] = 0;
  CurrValue[REG_GP] = SysGetGlobalPointer();
    
    
    
  FOREACH_BBL_INS(ibbl,iins)
    {
      REG ra = AINS_REG_A(iins);
      REG rb = AINS_REG_B(iins);
      REG rc = AINS_REG_C(iins);
      INT64 va = AINS_A_EVAL(iins);
      INT64 vb = AINS_B_EVAL(iins);
      INT64 vc = AINS_C_EVAL(iins);
      NUMBER oldest;
      REG    newreg;
      BOOL   isMemFormat;
	
      no++;
	
      /* ====================================================================== */
      /* REGISTER A */
      /* ====================================================================== */
	
      if( (AINS_FLAGS(iins) & FI_EVAL_A) &&
	  ra != REG_ZERO && ra != REG_LIT && ra != REG_FZERO && ra != REG_GP && ra != REG_SP &&
	  AINS_TYPE(iins) != IT_CST )
	{
	  if( hasValue & REG2BIT(ra) )
	    {
	      CASSERT(CurrValue[ra]==va,("iins %d ibbl %d ra %d new %lx old %lx\n",iins,AINS_BBL(iins),ra,CurrValue[ra],va));
	      if (CurrValue[ra]!=va)
		{
		  PrintBblSuper(stdout,ibbl);
		}
	    }
	  else
	    {
	      hasValue |= REG2BIT(ra);
	      CurrValue[ra] = va;
	    }
	    
	    
	  oldest = no;
	  newreg = ra;
	    
	  REGSET_FOREACH_REG(hasValue & (REG_IS_INT(ra) ? REGS_INT : REGS_FLT) ,reg) 
	    {
	      if( CurrValue[reg] != va ) continue;
	      if( oldest > LastDef[reg] )
		{
		  oldest = LastDef[reg];
		  newreg = reg;
		}
	    }
	    
	  if( newreg != ra )
	    {
	      if( verbose )
		{
		  fprintf(fp, "\t[*] bbl: %d ins: %d rename reg a %d -> %d (%016lx)\n",ibbl,iins,ra,newreg,va);
		  PrintIns(stdout,iins);
		}
		
	      AINS_REG_A(iins) = newreg;
	      if( ABBL_IS_HOT(ibbl) )
		pcounth++;
	      else
		pcount++;
	    }
	}
	
      /* ====================================================================== */
      /* REGISTER B (more oppportunities than with reg a because we can do an addition with
	 a constant in the instruction) */
      /* ====================================================================== */
	
      if( (AINS_FLAGS(iins) & FI_EVAL_B) &&
	  rb != REG_ZERO && rb != REG_LIT && rb != REG_FZERO && rb != REG_GP && rb != REG_SP )
	{
	  if( hasValue & REG2BIT(rb) )
	    {
	      CASSERT(CurrValue[rb]==vb,("rb %d new %lx old %lx\n",rb,CurrValue[rb],vb));
	    }
	  else
	    {
	      hasValue |= REG2BIT(rb);
	      CurrValue[rb] = vb;
	    }
	    
	  oldest = no;
	  newreg = rb;
	    
	  /*
	    we do not mess a lot with lda/ldah since if the base
	    register know the target register will be known as well
	  */
	    
	  if( (AINS_IS_LOAD(iins) || AINS_IS_STORE(iins)) && !AddressIsCode(vb) )
	    isMemFormat = 1;
	  else
	    isMemFormat = 0;
	    
	  REGSET_FOREACH_REG(hasValue & (REG_IS_INT(rb) ? REGS_INT : REGS_FLT),reg) 
	    {
	      if( isMemFormat && !AddressIsCode(CurrValue[reg]) )
		{
		  if( vb + AINS_DATA(iins) - CurrValue[reg] >= (1<<15) ) continue;
		  if( vb + AINS_DATA(iins) - CurrValue[reg] <  -(1<<15) ) continue;
		}
	      else
		{
		  if( vb != CurrValue[reg] ) continue;
		}
		
	      if( oldest > LastDef[reg] )
		{
		  oldest = LastDef[reg];
		  newreg = reg;
		}
	    }
	    
	  if( newreg != rb )
	    {
	      if( verbose )
		{
		  fprintf(fp,"\t[*] bbl: %d ins: %d rename reg b %d (%016lx) -> %d (%016lx)\n",
			  ibbl,iins,rb,vb,newreg,CurrValue[newreg]);
		  PrintIns(stdout,iins);
		  /*
		    PrintBblSuper(stdout,AINS_BBL(iins));
		  */
		}
		
	      if( isMemFormat )
		{
		  AINS_DATA(iins) =  vb + AINS_DATA(iins) - CurrValue[newreg];
		  AINS_B_EVAL(iins) = CurrValue[newreg];
		}

	      AINS_REG_B(iins) = newreg;
		
	      if( ABBL_IS_HOT(ibbl) )
		pcounth++;
	      else
		pcount++;
	    }
	    
	}
	
	
      /* ====================================================================== */
      /* REGISTER C */
      /* ====================================================================== */
	
      if( (AINS_FLAGS(iins) & FI_EVAL_C) )
	{
	  if( rc != REG_ZERO && rc != REG_LIT && rc != REG_FZERO && rc != REG_GP && rc != REG_SP )                
	    {
#if 1
	      if( !AddressIsCode(vc) && REG_IS_INT(rc) )
		isMemFormat = 1;
	      else
		isMemFormat = 0;
		
	      oldest = no;
	      newreg = INVALID;
		
	      REGSET_FOREACH_REG(hasValue & (REG_IS_INT(rc) ? REGS_INT: REGS_FLT),reg) 
		{
		  if( isMemFormat && !AddressIsCode(CurrValue[reg]) )
		    {
		      INT64 difference =  vc - CurrValue[reg];
		      if( difference >= (1<<15) ) continue;
		      if( difference <  -(1<<15) ) continue;
		    }
		  else
		    {
		      if( vc != CurrValue[reg] ) continue;
		    }
                        
		  if( oldest > LastDef[reg] )
		    {
		      oldest = LastDef[reg];
		      newreg = reg;
		    }
		}
                        
	      if( !AinsHasSideEffect(iins) && VALID(newreg) &&
		  AINS_TYPE(iins) != IT_FCS &&
		  /* AINS_TYPE(iins) != IT_FLD &&   float loads are faster than fcpys */
		  (AINS_TYPE(iins) != IT_LDA || (rb!=newreg && rb!=REG_GP && rb!=REG_ZERO) ))
		{
		  if( verbose )
		    {
		      fprintf(fp,"\t[*] bbl: %d  ins: %d rename reg c %d (%016lx) -> %d (%016lx)\n",
			      ibbl,iins,rc,vc,newreg,CurrValue[newreg]);
		      PrintIns(stdout,iins);
		      /*
			PrintBblSuper(stdout,AINS_BBL(iins));
		      */
		    }
                        
		  if( isMemFormat )
		    {
		      AinsMakeLda(iins,newreg,rc, vc - CurrValue[newreg]);
		    }
		  else
		    {
		      if( REG_IS_INT(rc) )
			{
			  AinsMakeLda(iins,newreg,rc, 0);
			}
		      else
			{
			  AinsMakeCpys(iins,newreg,newreg,rc);
			}
		    }
		    
		  AINS_FLAGS(iins) |= FI_EVAL_C;
		  AINS_C_EVAL(iins) = vc;
		    
                        
		  if( ABBL_IS_HOT(ibbl) )
		    pcounth++;
		  else
		    pcount++;
		}
                    
	      hasValue |= REG2BIT(rc);
	      CurrValue[rc] = vc;
	      LastDef[rc] = no;
	    }                    
#else
	  ;
#endif
	}
      else
	{
	  hasValue &= ~REG2BIT(rc);
	}
    }
    
  time = (clock() - time) * 1000 / CLOCKS_PER_SEC;
  change = pcount>0;

  //    InfoStatus(fp,"\t[OptConstgentwo%c] Modified ins: %d#%d {%d ms}\n",CHANGE(change),pcount,pcounth,time);

  return change;
}


